package com.alterdekim.services;

import com.alterdekim.Connection;
import com.alterdekim.Protocol;
import com.alterdekim.utils.BattleNetPacket;
import com.alterdekim.utils.Util;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

public class AccountService extends Service {

    private static final Logger log = LoggerFactory.getLogger(AccountService.class);

    public AccountService(String export_name) {
        super(export_name);
    }

    @Override
    public void process(BattleNetPacket packet, Connection conn) throws Exception {
        switch (packet.getHeader().getMethodId()) {
            case 30:
               // Protocol.GetAccountStateRequest getAccountStateRequest = Protocol.GetAccountStateRequest.parseFrom(packet.getBody());
              //  log.info(getAccountStateRequest.toString());

                Protocol.GetAccountStateResponse getAccountStateResponse = Protocol.GetAccountStateResponse
                        .newBuilder()
                        .setState(Protocol.AccountState.newBuilder()
                                .setAccountLevelInfo(Protocol.AccountLevelInfo.newBuilder()
                                        .setDefaultCurrency(4543826)
                                        .setPreferredRegion(1)
                                        .setCountry("SVK")
                                        .build())
                                .build())
                        .setTags(Protocol.AccountFieldTags.newBuilder()
                                .setAccountLevelInfoTag(-577802125).build())
                        .build();

                Protocol.Header header = Protocol.Header.newBuilder(packet.getHeader())
                                .setSize(getAccountStateResponse.getSerializedSize())
                                .setServiceId(254)
                                .setToken(packet.getHeader().getToken())
                                .setObjectId(0)
                                .setStatus(0)
                                .build();

                conn.send(new BattleNetPacket(header, getAccountStateResponse.toByteArray()));
                break;
            case 34:
                Protocol.Header header1 = Protocol.Header.newBuilder()
                        .setServiceId(254)
                        .setToken(packet.getHeader().getToken())
                        .setObjectId(0)
                        .setSize(53)
                        .setStatus(0)
                        .build();

                conn.send(new BattleNetPacket(header1, Util.hexStringToByteArray("12331880B5B9F50E221F0A0D36322E3139372E3234332E383810CBA6011A0A4272617469736C617661280030003800409AE5A1B905")));
                break;
            default:
                log.error("Can't process weird AccountService method: " + packet.getHeader().getMethodId());
                break;
        }
    }
}
